Package: scLang
Type: Package
Title: A unified language for interacting with Seurat and
        SingleCellExperiment
Version: 1.1.0
Authors@R: person('Andrei-Florian', 'Stoica', 
      email='andreistoica@foxmail.com',
     role=c('aut','cre'),
     comment=c(ORCID='0000-0002-5253-0826'))
Description: scLang is a suite for package development for scRNA-seq analysis. 
    It offers functions that can operate on both Seurat and 
    SingleCellExperiment objects. These functions are primarily aimed to help 
    developers build tools compatible with both types of input.
License: MIT + file LICENSE
Imports: dplyr, ggplot2, henna, methods, paletteer, rlang, S4Vectors,
        SeuratObject, SingleCellExperiment, stats, SummarizedExperiment
Suggests: BiocStyle, knitr, qs2, rmarkdown, scater, scRNAseq, Seurat,
        testthat (>= 3.0.0)
biocViews: Software, SingleCell, GeneExpression, Visualization
Encoding: UTF-8
URL: https://github.com/andrei-stoica26/scLang
BugReports: https://github.com/andrei-stoica26/scLang/issues
RoxygenNote: 7.3.3
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/scLang
git_branch: devel
git_last_commit: c70c598
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:58:30 UTC; biocbuild
Author: Andrei-Florian Stoica [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5253-0826>)
Maintainer: Andrei-Florian Stoica <andreistoica@foxmail.com>

# scLang

`scLang` is a suite for package development for scRNA-seq analysis. 
It offers functions that can operate on both `Seurat` and 
`SingleCellExperiment` objects. These functions are primarily aimed to help 
developers build tools compatible with both types of input.

## Installation

To install `scLang`, run the following R code:

```r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
    
BiocManager::install("scLang")
```

scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
seuratPath <- system.file('extdata', 'seuratObj.qs2', package='scLang')
seuratObj <- qs2::qs_read(seuratPath)

#' @importFrom dplyr count
#'
NULL

#' Extract per-group counts from the column of a single-cell expression object
#'
#' This function extracts per-group counts from the column of single-cell
#' expression object.
#'
#' @inheritParams metadataDF
#' @param col Column as string.
#'
#' @return A frequency vector with the unique column values as names.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' scColCounts(sceObj, 'Cluster')
#'
#' @export
#'
scColCounts <- function(scObj, col='orig.ident'){
    df <- dplyr::count(metadataDF(scObj), .data[[col]])
    v <- setNames(df[, 2], as.factor(df[, 1]))
    return(v)
}

#' Extract counts from two columns of a single-cell expression
#' object
#'
#' This function extracts count information from two columns of a single-cell
#' expression object.
#'
#' @inheritParams metadataDF
#' @param col1 Column as string.
#' @param col2 Column as string.
#'
#' @return A data frame listing the counts of all combinations of pairs from
#' two categorical columns.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' scColPairCounts(sceObj, 'Cluster', 'Donor')
#'
#' @export
#'
scColPairCounts <- function(scObj, col1='seurat_clusters', col2='orig.ident')
    return(dplyr::count(metadataDF(scObj), .data[[col1]], .data[[col2]]))

#' Extract percentages from two columns of a single-cell expression
#' object
#'
#' This function extracts percentage information from two columns of a
#' single-cell expression object. For each i x j combination with i taken
#' from column 1 and j taken from column 2, the function reports the percentage
#' that i contributes to all combinations involving j.
#'
#' @inheritParams scColPairCounts
#' @param sigDigits Number of significant digits.
#'
#' @return A data frame listing the percentages of all combinations of pairs
#' from two categorical columns.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' scColPairPercs(sceObj, 'Cluster', 'Donor')
#'
#' @export
#'
scColPairPercs <- function(scObj, col1, col2, sigDigits = 2){
    df <- scColPairCounts(scObj, col1, col2)
    totals <- vapply(unique(df[, 2]), function(x)
        sum(df[df[, 2] == x, ]$n), integer(1))
    df$perc <- round(df[, 3] / totals[df[, 2]] * 100, sigDigits)
    return(df)
}

# A self-contained script to generate the data in inst/extdata
#'
createExtData <- function(){
    if (requireNamespace(c('Matrix', 'qs2', 'Seurat', 'withr'),
                         quietly=TRUE)){

        nGenes <- 500
        nCells <- 200

        countsMat <- withr::with_seed(1, matrix(
            rnbinom(nGenes * nCells, size=5, mu=5),
            nrow = nGenes))

        countsMat[withr::with_seed(1, sample(length(countsMat),
                             0.7 * length(countsMat)))] <- 0
        countsMat <- Matrix::Matrix(countsMat, sparse=TRUE)

        rownames(countsMat) <- paste0("Gene", seq(nGenes))
        colnames(countsMat) <- paste0("Cell", seq(nCells))

        seuratObj <- CreateSeuratObject(countsMat)
        seuratObj <- NormalizeData(seuratObj)
        seuratObj <- FindVariableFeatures(seuratObj)
        seuratObj <- ScaleData(seuratObj)
        seuratObj <- withr::with_seed(1, RunPCA(seuratObj))
        seuratObj <- withr::with_seed(1, RunUMAP(seuratObj, dims=1:30))

        scCol(seuratObj, 'Cluster') <- withr::with_seed(1,
                                                     sample(paste0('Cluster',
                                                                   seq(5)),
                                                            dim(seuratObj)[2],
                                                            replace=TRUE))
        scCol(seuratObj, 'Donor') <- rep('Donor1', dim(seuratObj)[2])
        for (i in seq(5)){
            scCol(seuratObj, 'Donor')[withr::with_seed(1,
                                                    sample(which(scCol(seuratObj, 'Cluster') == paste0('Cluster', i))
                                                           , 15))]<- paste0('Donor', i)
            scCol(seuratObj, 'Donor')[withr::with_seed(1,
                                                    sample(which(scCol(seuratObj,
                                                                       'Cluster') ==
                                                                     paste0('Cluster', i))
                                                           , 15))]<- paste0('Donor', i + 1)
        }
        qs2::qs_save(seuratObj, 'inst/extdata/seuratObj.qs2')
        sceObj <- as.SingleCellExperiment(seuratObj)
        qs2::qs_save(sceObj, 'inst/extdata/sceObj.qs2')
    }
}

createExtData()

#' @importFrom rlang .data
#' @importFrom S4Vectors DataFrame
#' @importFrom SeuratObject Embeddings LayerData Layers Reductions
#' @importFrom SingleCellExperiment reducedDim reducedDims
#' @importFrom stats setNames
#' @importFrom SummarizedExperiment assay assayNames colData colData<-
#'
NULL

################################################################################
#' @rdname scGeneExp
#' @export
#'
scGeneExp.default <- function(scObj, gene, slot = NULL)
    stop('Unrecognized input type: scObj must be a Seurat, ',
         'SingleCellExpression, matrix or dgCMatrix object')

#' @param slot Slot where expression data is accessed. Default is 'data' for
#' Seurat objects and 'logcounts' for SingleCellExpression objects.
#'
#' @rdname scGeneExp
#' @export
#'
scGeneExp.Seurat <- function(scObj, gene, slot = 'data'){
    if (!slot %in% Layers(scObj))
        stop('Layer `', slot, '` not found for the current assay.')
    return(LayerData(scObj, slot)[gene, ])
}

#' @param slot Expression data type. Must be one of 'counts' and
#' 'logcounts'.
#'
#' @rdname scGeneExp
#' @export
#'
scGeneExp.SingleCellExperiment <- function(scObj,
                                           gene,
                                           slot = 'logcounts'){
    if (!slot %in% assayNames(scObj))
        stop('Assay `', slot, '` not found.')
    return(assay(scObj, slot)[gene, ])
}

#' @rdname scGeneExp
#' @export
#'
scGeneExp.dgCMatrix <- function(scObj, gene, slot = NULL)
    return(scObj[gene, ])

#' @rdname scGeneExp
#' @export
#'
scGeneExp.matrix <- function(scObj, gene, slot = NULL)
    return(scObj[gene, ])

################################################################################
#' @rdname scExpMat
#' @export
#'
scExpMat.default <- function(scObj,
                             slot = NULL,
                             genes = NULL,
                             densify = TRUE)
    stop('Unrecognized input type: `scObj` must be a Seurat, ',
         'SingleCellExpression, matrix or dgCMatrix object.')

#' @rdname scExpMat
#' @export
#'
scExpMat.Seurat <- function(scObj,
                            slot = 'data',
                            genes = NULL,
                            densify = TRUE){
    if (!slot %in% Layers(scObj))
        stop('Layer `', slot, '` not found for the current assay.')
    mat <- LayerData(scObj, layer=slot)
    if (!is.null(genes))
        mat <- mat[genes, ]
    if(densify)
        mat <- as.matrix(mat)
    return(mat)
}

#' @rdname scExpMat
#' @export
#'
scExpMat.SingleCellExperiment <- function(scObj,
                                          slot = 'logcounts',
                                          genes = NULL,
                                          densify = TRUE){

    if (!slot %in% assayNames(scObj))
        stop('Assay `', slot, '` not found.')
    mat <- assay(scObj, slot)
    if (!is.null(genes))
        mat <- mat[genes, ]
    if(densify)
        mat <- as.matrix(mat)
    return(mat)
}

#' @rdname scExpMat
#' @export
#'
scExpMat.dgCMatrix <- function(scObj,
                               slot = NULL,
                               genes = NULL,
                               densify = TRUE){

    if (!is.null(genes))
        mat <- scObj[genes, ]
    if(densify)
        mat <- as.matrix(mat)
    return(mat)
}

#' @rdname scExpMat
#' @export
#'
scExpMat.matrix <- function(scObj,
                            slot = NULL,
                            genes = NULL,
                            densify = TRUE){

    if (!is.null(genes))
        scObj <- scObj[genes, ]
    return(scObj)
}

#' Extract feature data to be used by \code{featurePlot} or \code{violinPlot}
#'
#' This function extracts feature data to be used by \code{featurePlot}
#' or \code{violinPlot}.
#'
#' @inheritParams documentFun
#' @param feature A gene name or metadata column name.
#'
#' @return A numeric vector.
#'
#' @keywords internal
#'
pickFeature <- function(scObj, feature){
    if (feature %in% rownames(scObj))
        return(scExpMat(scObj, genes=feature)[, 1])

    if (feature %in% metadataNames(scObj)){
        col <- scCol(scObj, feature)
        if (!is.numeric(col))
            stop(feature, ' is not a numeric column.')
        return(col)
    }
    stop('Feature not found: ', feature, '.')
}

#' @importFrom ggplot2 aes element_text ggplot geom_jitter geom_point
#' @importFrom ggplot2 geom_violin labs scale_color_gradientn
#' @importFrom ggplot2 scale_color_manual scale_fill_manual theme theme_classic
#' @importFrom henna centerTitle
#' @importFrom methods is
#' @importFrom paletteer paletteer_c paletteer_d
#'
NULL

#' Creates a dimensionality reduction plot
#'
#' This function creates a dimensionality reduction plot
#'
#' @inheritParams documentFun
#' @param noGroupsLegendLab Legend label to be used when no grouping is
#' provided (\code{groupBy} is \code{NULL})
#'
#' @return A dimensionality reduction plot.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' dimPlot(sceObj, groupBy='Donor')
#'
#' @export
#'
dimPlot <- function(scObj,
                    groupBy = NULL,
                    title = NULL,
                    dimred = 'umap',
                    dims = c(1, 2),
                    legendTitle = 'Group',
                    noGroupsLegendLab = 'Object',
                    palette = 'grDevices::rainbow',
                    pointSize = 0.5,
                    alpha = 0.7,
                    legendPos = c('right', 'top', 'left', 'bottom'),
                    legendTextSize = 10,
                    legendTitleSize = 10,
                    axisTextSize = 12,
                    axisTitleSize = 12,
                    ...
                    ){
    legendPos <- match.arg(legendPos, c('right', 'top', 'left', 'bottom'))
    dimred <- dimredName(scObj, dimred)
    df <- as.data.frame(scDimredMat(scObj, dimred)[, dims])
    if(is.null(groupBy)){
        df[[noGroupsLegendLab]] <- noGroupsLegendLab
        legendTitle <- NULL
    } else
        df[[groupBy]] <- scCol(scObj, groupBy)

    nColors <- length(unique(df[, 3]))
    p <- ggplot(df) + geom_point(aes(x=df[, 1],
                                     y=df[, 2],
                                     color=df[, 3]),
                                 size=pointSize,
                                 alpha=alpha) +
        labs(x=paste0(dimred, '_', dims[1]),
             y=paste0(dimred, '_', dims[2]),
             color=legendTitle) +
        scale_color_manual(values=paletteer_c(palette, nColors)) +
        theme_classic() +
        theme(legend.position=legendPos,
              legend.text=element_text(size=legendTextSize),
              legend.title=element_text(size=legendTitleSize),
              axis.text=element_text(size=axisTextSize),
              axis.title=element_text(size=axisTitleSize))

    p <- centerTitle(p, title, ...)
    return(p)
}

#' Create a dimensionality reduction plot to represent a feature
#'
#' This function creates a dimensionality reduction plot to represent a
#' feature (gene expression or numeric metadata column).
#'
#' @inheritParams documentFun
#' @inheritParams pickFeature
#'
#' @return A feature plot.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' featurePlot(sceObj, 'Gene289')
#'
#' @export
#'
featurePlot <- function(scObj,
                        feature = rownames(scObj)[1],
                        title = feature,
                        dimred = 'umap',
                        dims = c(1, 2),
                        legendTitle = NULL,
                        palette = paletteer_d("wesanderson::Royal1")[c(3, 2)],
                        pointSize = 0.5,
                        alpha = 0.6,
                        legendPos = c('right', 'top', 'left', 'bottom'),
                        legendTextSize = 10,
                        legendTitleSize = 10,
                        axisTextSize = 12,
                        axisTitleSize = 12,
                        ...){

    legendPos <- match.arg(legendPos, c('right', 'top', 'left', 'bottom'))

    if (length(dims) != 2)
        stop('`dims` must be a vector of size 2.')

    dimred <- dimredName(scObj, dimred)
    df <- as.data.frame(scDimredMat(scObj, dimred)[, dims])
    df[, 3] <- pickFeature(scObj, feature)
    colnames(df)[3] <- feature

    p <- ggplot(df) + geom_point(aes(x=df[, 1],
                                     y=df[, 2],
                                     color=df[, 3]),
                                 size=pointSize,
                                 alpha=alpha) +
        labs(x=paste0(dimred, '_', dims[1]),
             y=paste0(dimred, '_', dims[2]),
             color=legendTitle) +
        scale_color_gradientn(colors=palette) +
        theme_classic() +
        theme(legend.position=legendPos,
              legend.text=element_text(size=legendTextSize),
              legend.title=element_text(size=legendTitleSize),
              axis.text=element_text(size=axisTextSize),
              axis.title=element_text(size=axisTitleSize))

    p <- centerTitle(p, title, ...)
    return(p)
}

#' Create a violin plot to represent a feature
#'
#' This function creates a violin plot to represent a
#' feature (gene expression or numeric metadata column).
#'
#' @inheritParams documentFun
#' @inheritParams pickFeature
#' @param xLabAngle x axis label angle.
#' @param xLabVjust x axis label vertical justification in [0, 1].
#'
#' @return A violin plot.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' violinPlot(sceObj, 'Gene289')
#'
#' @export
#'
violinPlot <- function(scObj,
                       feature = rownames(scObj)[1],
                       groupBy = metadataNames(scObj)[1],
                       title = feature,
                       legendTitle = NULL,
                       xLab = 'Identity',
                       yLab = 'Expression level',
                       palette = 'grDevices::rainbow',
                       pointSize = 0.5,
                       alpha = 0.8,
                       legendPos = c('right', 'top', 'left', 'bottom'),
                       legendTextSize = 10,
                       legendTitleSize = 10,
                       axisTextSize = 12,
                       axisTitleSize = 12,
                       xLabAngle = 45,
                       xLabVjust = 0.5,
                       ...){

    legendPos <- match.arg(legendPos, c('right', 'top', 'left', 'bottom'))
    df <- data.frame(x = scCol(scObj, groupBy),
                     y = pickFeature(scObj, feature))
    nColors <- length(unique(df[, 1]))

    p <- ggplot(df, aes(x=df[, 1], y=df[, 2], fill=df[, 1])) +
        geom_violin(alpha=alpha) +
        geom_jitter(height=0, width=0.3, size=pointSize) +
        labs(x=xLab,
             y=yLab,
             fill=legendTitle) +
        scale_fill_manual(values=paletteer_c(palette, nColors)) +
        theme_classic() +
        theme(legend.position=legendPos,
              legend.text=element_text(size=legendTextSize),
              legend.title=element_text(size=legendTitleSize),
              axis.text.x=element_text(size=axisTextSize,
                                       angle=xLabAngle,
                                       vjust=xLabVjust),
              axis.text.y=element_text(size=axisTextSize),
              axis.title=element_text(size=axisTitleSize))

    p <- centerTitle(p, title, ...)
    return(p)
}

#' @rdname scDimredMat
#' @export
#'
scDimredMat.default <- function(scObj, dimred)
    stop('Unrecognized input type: `scObj` must be a Seurat or ',
         'SingleCellExpression object.')

#' @rdname scDimredMat
#' @export
#'
scDimredMat.Seurat <- function(scObj, dimred)
{
    reductions <- dimredNames(scObj)
    dimred <- dimredName(scObj, dimred)
    return(as.matrix(Embeddings(scObj, reduction=dimred)))
}

#' @rdname scDimredMat
#' @export
#'
scDimredMat.SingleCellExperiment <- function(scObj, dimred){
    reductions <- dimredNames(scObj)
    dimred <- dimredName(scObj, dimred)
    return(reducedDim(scObj, dimred))
}

#' Extracts the PCA matrix from object.
#'
#' This function extracts the PCA matrix from a Seurat or
#' SingleCellExperiment object.
#'
#' @inheritParams metadataDF
#'
#' @return A PCA matrix.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' pcaMat <- scPCAMat(sceObj)
#'
#' @export
#'
scPCAMat <- function(scObj)
    return(scDimredMat(scObj, 'pca'))

#' Extracts the UMAP matrix from object.
#'
#' This function extracts the UMAP matrix from a Seurat or
#' SingleCellExperiment object.
#'
#' @inheritParams metadataDF
#'
#' @return A UMAP matrix.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' umapMat <- scUMAPMat(sceObj)
#'
#' @export
#'
scUMAPMat <- function(scObj)
    return(scDimredMat(scObj, 'umap'))

#' Correct the case of the input dimensionality reduction name if necessary
#'
#' This function corrects, if necessary, the case of the input dimensionality
#' reduction name. The dimensionality reduction must be available in the object
#' whether in upper or in lower case. Otherwise, the function will return
#' an error.
#'
#' @inheritParams scDimredMat
#'
#' @return The dimensionality reduction name.
#'
#' @noRd
#'
dimredName <- function(scObj, dimred){
    lowerDimred <- tolower(dimred)
    upperDimred <- toupper(dimred)
    dimName <- intersect(dimredNames(scObj), c(dimred, lowerDimred,
                                               upperDimred))
    if (!length(dimName))
        stop('No `', lowerDimred, '` or `', upperDimred,
             '` reduction was found in the object.')
    if (length(dimName) > 1){
        warning('Both `', lowerDimred, '` and ', upperDimred,
                '` reductions were found. Returning ', dimred, '.')
        return(dimred)
    }
    return(dimName)
}

###############################################################################

#' @rdname dimredNames
#' @export
#'
dimredNames.default <- function(scObj)
    stop('Unrecognized input type: `scObj` must be a Seurat, ',
         'SingleCellExpression, matrix or dgCMatrix object.')

#' @rdname dimredNames
#' @export
#'
dimredNames.Seurat <- function(scObj)
    return(Reductions(scObj))


#' @rdname dimredNames
#' @export
#'
dimredNames.SingleCellExperiment <- function(scObj)
    return(names(reducedDims(scObj)))

###############################################################################
#' @rdname metadataDF
#' @export
#'
metadataDF.default <- function(scObj)
    stop('Unrecognized input type: `scObj` must be a Seurat or ',
         'SingleCellExpression object.')

#' @rdname metadataDF
#' @export
#'
metadataDF.Seurat <- function(scObj)
    return(scObj[[]])

#' @rdname metadataDF
#' @export
#'
metadataDF.SingleCellExperiment <- function(scObj)
    return(as.data.frame(colData(scObj)))

###############################################################################
#' Return metadata names
#'
#' This function extracts metadata names from a Seurat or
#' SingleCellExperiment object. It can also be used to modify metadata names.
#'
#' @inheritParams metadataDF
#'
#' @return The names of the metadata columns.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' colNames <- metadataNames(sceObj)
#'
#' @export
#'
metadataNames <- function(scObj)
    return(colnames(metadataDF(scObj)))

###############################################################################
#' @rdname scCol
#' @export
#'
scCol.default <- function(scObj, col)
    stop('Unrecognized input type: `scObj` must be a Seurat or ',
         'SingleCellExpression object')

#' @rdname scCol
#' @export
#'
`scCol<-.default` <- function(scObj, col, value)
    stop('Unrecognized input type: `scObj` must be a Seurat or ',
         'SingleCellExpression object.')

#' @rdname scCol
#' @export
#'
scCol.Seurat <- function(scObj, col){
    if (col %in% metadataNames(scObj))
        return(metadataDF(scObj)[[col]])
    stop(col, ' not found in this Seurat object.')
}

#' @rdname scCol
#' @export
#'
`scCol<-.Seurat` <- function(scObj, col, value){
    scObj[[col]] <- value
    return(scObj)
}

#' @rdname scCol
#' @export
#'
scCol.SingleCellExperiment <- function(scObj, col){
    if (col %in% metadataNames(scObj))
        return(metadataDF(scObj)[[col]])
    stop(col, ' not found in this SingleCellExperiment object.')
}

#' @rdname scCol
#' @export
#'
`scCol<-.SingleCellExperiment` <- function(scObj, col, value){
    colData(scObj)[[col]] <- value
    return(scObj)
}

#' Internal function used for documenting other functions
#'
#' This function is used internally to help document other functions.
#'
#' @inheritParams scDimredMat
#' @param title Plot title.
#' @param groupBy Grouping variable. Must exist in the metadata/coldata of
#' the single-cell expression object.
#' @param dims A numeric vector of size 2 representing the dimensions selected
#' for the plot.
#' @param xLab x axis label.
#' @param yLab y axis label.
#' @param legendTitle Legend title.
#' @param legendLabs Legend labels.
#' @param legendPos Legend position.
#' @param palette Color palette.
#' @param alpha Opaqueness level.
#' @param pointSize Point size.
#' @param legendTitleSize Legend title size.
#' @param legendTextSize Legend text size.
#' @param axisTextSize Axis text size.
#' @param axisTitleSize Axis title size.
#' @param ... Additional arguments passed to \code{henna::centerTitle}.
#'
#' @return \code{NULL}. This function is only used internally for
#' documentation.
#'
#' @keywords internal

documentFun <- function(scObj = NULL,
                        title = NULL,
                        groupBy = NULL,
                        dimred = 'umap',
                        dims = c(1, 2),
                        xLab = 'x',
                        yLab = 'y',
                        legendTitle = 'Legend',
                        legendLabs = c('a', 'b'),
                        legendPos = 'right',
                        palette = 'Spectral',
                        alpha = 1,
                        pointSize = 0.8,
                        legendTitleSize = 10,
                        legendTextSize = 10,
                        axisTextSize = 12,
                        axisTitleSize = 12,
                        ...){}

#' Extract the names of available dimensionality reductions from object
#'
#' This function extracts the names of available dimensionality reductions
#' from a \code{Seurat} or \code{SingleCellExperiment} object.
#'
#' @inheritParams metadataNames
#'
#' @return A character vector.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' dimredNames(sceObj)
#'
#' @export
#'
dimredNames <- function(scObj)
    UseMethod(generic='dimredNames', object=scObj)

#' Extract metadata from object as a data frame
#'
#' This function extracts the metadata from a \code{Seurat} or
#' \code{SingleCellExperiment} object as a data frame.
#'
#' @param scObj A \code{Seurat} or \code{SingleCellExperiment} object.
#'
#' @return A metadata data frame.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' df <- metadataDF(sceObj)
#'
#' @export
#'
metadataDF <- function(scObj)
    UseMethod(generic='metadataDF', object=scObj)

#' Extract a metadata/coldata column from object.
#'
#' This function extracts a metadata/coldata column from a \code{Seurat} or
#' \code{SingleCellExperiment} object.
#'
#' @inheritParams metadataNames
#' @param col Column name.
#' @param value A vector to be added to the metadata/coldata of the
#' single-cell expression object.
#'
#' @return A vector.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' v <- scCol(sceObj, 'Cluster')
#'
#' @export
#'
scCol <- function(scObj, col)
    UseMethod(generic='scCol', object=scObj)

#' @rdname scCol
#' @export
#'
`scCol<-` <- function(scObj, col, value)
    UseMethod("scCol<-")

#' Extracts a dimensionality reduction matrix from object.
#'
#' This function extracts a dimensionality reduction matrix from a
#' \code{Seurat} or \code{SingleCellExperiment} object.
#'
#' @inheritParams metadataNames
#' @param dimred Dimensionality reduction.
#'
#' @return A dimensionality reduction matrix.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' pcaMat <- scDimredMat(sceObj, 'pca')
#'
#'
#' @export
#'
scDimredMat <- function(scObj, dimred)
    UseMethod(generic='scDimredMat', object=scObj)

#' Extracts the expression matrix from object.
#'
#' This function extracts an expression matrix from a \code{Seurat} or
#' \code{SingleCellExperiment} object. For additional flexibility, the input
#' can alternatively be provided as a \code{dgCMatrix} object
#' (and an option to densify it is also available) or as a \code{matrix}
#' object.
#'
#' @inheritParams scGeneExp
#' @param genes Selected genes. If \code{NULL}, all genes will be retained.
#' @param densify Whether to convert to dense matrix.
#'
#' @return An expression matrix.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' mat <- scExpMat(sceObj, 'counts')
#'
#' @export
#'
scExpMat <- function(scObj, slot, genes = NULL, densify = TRUE)
    UseMethod(generic='scExpMat', object=scObj)

#' Extracts the expression of a single gene
#'
#' This function extracts the expression of a single gene from a \code{Seurat},
#' \code{SingleCellExperiment}, \code{dgCMatrix} or \code{matrix} object.
#
#' @param scObj A \code{Seurat}, \code{SingleCellExperiment},
#' \code{dgCMatrix} or \code{matrix} object.
#' @param gene Selected gene.
#' @param slot Gene expression slot. Ignored if \code{scObj} is of class
#' \code{dgCMatrix} or \code{matrix}.
#'
#' @return A gene expression vector.
#'
#' @examples
#' scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
#' sceObj <- qs2::qs_read(scePath)
#' v <- scGeneExp(sceObj, 'Gene291')
#'
#' @export
#'
scGeneExp <- function(scObj, gene, slot)
    UseMethod(generic='scGeneExp', object=scObj)

test_that("dimredNames works", {
    expect_identical(dimredNames(sceObj), c('PCA', 'UMAP'))
    expect_identical(dimredNames(seuratObj), c('pca', 'umap'))
    expect_error(dimredNames(c(1, 2, 3)))
})

test_that("metadataDF works", {
    v <- metadataDF(seuratObj)
    w <- metadataDF(sceObj)
    expect_equal(dim(v), c(200, 5))
    expect_equal(dim(w), c(200, 6))
    expect_error(metadataDF(c(1, 2, 3)))
})

test_that("metadataNames works", {
    cols <- c('orig.ident', 'nCount_RNA', 'nFeature_RNA', 'Cluster', 'Donor')
    expect_equal(metadataNames(seuratObj), cols)
    expect_equal(metadataNames(sceObj), c(cols, 'ident'))
    expect_error(metadataNames(c(1, 2, 3)))
})

test_that("scCol works", {
    scCol(seuratObj, 'featCountRatio') <-
        scCol(seuratObj, 'nFeature_RNA') / scCol(seuratObj, 'nCount_RNA')
    expect_equal(mean(scCol(seuratObj, 'featCountRatio')), 0.1934944,
                 tolerance=0.0001)
    scCol(sceObj, 'featCountRatio') <-
        scCol(sceObj, 'nFeature_RNA') / scCol(sceObj, 'nCount_RNA')
    expect_equal(mean(scCol(sceObj, 'featCountRatio')), 0.1934944,
                 tolerance=0.0001)
    expect_error(scCol(c(1, 2, 3)))
    expect_error(scCol(seuratObj, 'noCol'))
    expect_error(scCol(sceObj, 'noCol'))
})

test_that("counting functions work", {
    expect_equal(scColCounts(seuratObj, 'Donor')['Donor1'],
                 setNames(125, 'Donor1'))
    expect_equal(scColCounts(sceObj, 'Donor')['Donor1'],
                 setNames(125, 'Donor1'))
    expect_error(scColCounts(c(1, 2, 3)))

    expect_equal(scColPairCounts(seuratObj, 'Cluster', 'Donor')[1, 3],
                 32)
    expect_equal(scColPairCounts(sceObj, 'Cluster', 'Donor')[1, 3],
                 32)
    expect_error(scColPairCounts(c(1, 2, 3)))

    expect_equal(scColPairPercs(seuratObj, 'Cluster', 'Donor')[1, 4],
                 25.6)
    expect_equal(scColPairPercs(sceObj, 'Cluster', 'Donor')[1, 4],
                 25.6)
    expect_error(scColPairPercs(c(1, 2, 3)))
})

test_that("scGeneExp works", {
    expect_equal(length(scGeneExp(sceObj, 'Gene474')), 200)
    expect_equal(length(scGeneExp(seuratObj, 'Gene474')), 200)
    expect_equal(mean(scGeneExp(sceObj, 'Gene474')), 1.311307,
                 tolerance=0.0001)
    expect_equal(mean(scGeneExp(seuratObj, 'Gene474')), 1.311307,
                 tolerance=0.0001)
    mat <- scExpMat(sceObj)
    expect_equal(mean(scGeneExp(mat, 'Gene474')), 1.311307,
                 tolerance=0.0001)
    expect_error(scGeneExp(sceObj, 'missingGene'))
    expect_error(scGeneExp(seuratObj, 'missingGene'))
    expect_error(scGeneExp(c(1, 2, 3)))
})

test_that("scExpMat works", {
    v <- scExpMat(sceObj)
    w <- scExpMat(seuratObj)
    expect_identical(v, w)
    mat <- scExpMat(v)
    expect_identical(mat, v)
    expect_equal(dim(v), c(500, 200))

    v <- scExpMat(sceObj, slot='counts')
    w <- scExpMat(seuratObj, slot='counts')
    expect_identical(v, w)
    expect_error(scExpMat(sceObj, slot='missingSlot'))
    expect_error(scExpMat(seuratObj, slot='missingSlot'))
    expect_equal(dim(v), c(500, 200))

    v <- scExpMat(sceObj, genes=c('Gene285', 'Gene287', 'Gene291'))
    w <- scExpMat(seuratObj, genes=c('Gene285', 'Gene287', 'Gene291'))
    expect_equal(dim(v), c(3, 200))
    expect_identical(v, w)
    mat <- scExpMat(v)
    expect_identical(mat, v)
    expect_error(scExpMat(seuratObj, genes=c('Gene285', 'noGene')))
    expect_error(scExpMat(c(1, 2, 3)))
})

test_that("scExpMat works for sparse matrices", {
    v <- scExpMat(sceObj, densify=FALSE)
    w <- scExpMat(seuratObj, densify=FALSE)
    expect_identical(v, w)
    expect_equal(dim(v), c(500, 200))
})

test_that("scPCAMat works", {
    v <- scPCAMat(sceObj)
    w <- scPCAMat(seuratObj)
    expect_identical(v, w)
    expect_equal(dim(v), c(200, 50))
    expect_error(scPCAMat(c(1, 2, 3)))
})

test_that("scUMAPMat works", {
    v <- scUMAPMat(sceObj)
    w <- scUMAPMat(seuratObj)
    expect_identical(v, w)
    expect_equal(dim(v), c(200, 2))
    expect_error(scUMAPMat(c(1, 2, 3)))
})

test_that("visualization functions work", {
    p <- dimPlot(sceObj, groupBy='Donor')
    expect_equal(length(intersect(is(p), c('gg', 'ggplot2::ggplot'))), 1)

    p <- featurePlot(sceObj, 'Gene289')
    expect_equal(length(intersect(is(p), c('gg', 'ggplot2::ggplot'))), 1)

    p <- featurePlot(sceObj, 'nCount_RNA')
    expect_equal(length(intersect(is(p), c('gg', 'ggplot2::ggplot'))), 1)

    p <- violinPlot(sceObj, 'Gene289')
    expect_equal(length(intersect(is(p), c('gg', 'ggplot2::ggplot'))), 1)

    p <- violinPlot(sceObj, 'nCount_RNA')
    expect_equal(length(intersect(is(p), c('gg', 'ggplot2::ggplot'))), 1)

    expect_error(featurePlot(sceObj, 'missingFeat'))
    expect_error(violinPlot(sceObj, 'missingFeat'))
})

---
title: "Introduction to scLang"
author: "Andrei-Florian Stoica"
package: scLang
date: March 3, 2026
output: BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{scLang}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

`scLang` is a suite for package development for scRNA-seq analysis. 
It offers functions that can operate on both `Seurat` and 
`SingleCellExperiment` objects. These functions are primarily 
aimed to help developers build tools compatible with both types of input.

# Installation

To install `scLang`, run the following commands in an R session:

```{r setup, eval=FALSE}
if (!require("BiocManager", quietly=TRUE))
    install.packages("BiocManager")

BiocManager::install("scLang")
```

# Prerequisites
In addition to `scLang`, you need to install 
[scater](https://bioconductor.org/packages/release/bioc/html/scater.html) and 
[scRNAseq](https://bioconductor.org/packages/release/data/experiment/html/scRNAseq.html)
for this tutorial.

# Loading and preparing data

This tutorial uses an scRNA-seq human pancreas dataset. After loading the 
required packages, download the dataset using the `BaronPancreasData` function 
from `scRNAseq`. The dataset will be stored as a SingleCellExperiment object. 

```{r message=FALSE, warning=FALSE, results=FALSE}
library(scLang)
library(scRNAseq)
library(scater)
library(Seurat)

sceObj <- BaronPancreasData('human')
```

Next, we will normalize and log-transform the data using the `logNormCounts` 
function from `scuttle` (loaded automatically with `scater`):

```{r message=FALSE, warning=FALSE, results=FALSE}
sceObj <- logNormCounts(sceObj)
```

We will also need PCA and UMAP dimensions. These can be computed using the 
`runPCA` and `runUMAP` functions from `scater`:

```{r message=FALSE, warning=FALSE, results=FALSE}
sceObj <- runPCA(sceObj)
sceObj <- runUMAP(sceObj)
```

Now we will convert the dataset to a Seurat object:

```{r message=FALSE, warning=FALSE, results=FALSE}
seuratObj <- as.Seurat(sceObj)
```


# Extracting the expression matrix

The `scExpMat` function extracts the expression matrix from a `Seurat` or 
`SingleCellExperiment` object:

```{r message=FALSE, warning=FALSE}
mat1 <- scExpMat(sceObj)
dim(mat1)
mat2 <- scExpMat(seuratObj)
identical(mat1, mat2)
```

**Note**: By default, this function extracts normalized and log-transformed 
data, looking for the `data` assay for a `Seurat` object, and for the 
`logcounts` assay for a `SingleCellExperiment` object. This behavior 
can be changed using the `dataType` parameter.

`scExpMat` can also take a matrix as an argument. This option is useful when 
building functions allowing users to use either a single-cell expression matrix 
or an object of a dedicated class (`Seurat`, `SingleCellExperiment`) as input:

```{r}
mat2 <- scExpMat(mat1)
identical(mat1, mat2)
```

By default, `scExpMat`converts the expression matrix to a dense matrix. 
If this behavior is not desired, conversion can be skipped by setting `densify`
to `FALSE`:

```{r}
is(mat1)[1]
mat2 <- scExpMat(sceObj, densify=FALSE)
is(mat2)[2]
```

`scExpMat`can also extract the expression data only for selected genes:

```{r}
mat2 <- scExpMat(sceObj, genes=rownames(sceObj)[seq(30, 80)])
dim(mat2)
```

# Extracting and altering metadata/coldata columns

The `scCol` function extracts a column from the metadata of the `Seurat` 
object or the coldata of the `SingleCellExperiment` object:

```{r}
col1 <- scCol(seuratObj, 'label')
col2 <- scCol(sceObj, 'label')
identical(col1, col2)
head(col1)
```

It can also be used to insert a new column. Here, we just make a modified
copy of the `label` column for the `Seurat` object:

```{r}
scCol(seuratObj, 'labelCopy') <- paste0(scCol(seuratObj, 'label'), '_copy')
head(seuratObj[['labelCopy']])
```

# Extracting and altering the metadata/coldata or its column names

The `metadataDF` function extracts the metadata/coldata data frame from a
`Seurat` or `SingleCellExpression` object:

```{r}
df1 <- metadataDF(seuratObj)
df2 <- metadataDF(sceObj)
identical(df1, df2)
head(df1)[, c(1, 2)]
```

The `metadataNames` function extracts the column names of the metadata/coldata 
data frame from a Seurat or SingleCellExpression object:

```{r}
colNames1 <- metadataNames(seuratObj)
colNames2 <- metadataNames(sceObj)
identical(colNames1, colNames2)
head(colNames1)
```

# Creating frequency tables

The `scColCounts` and `scColPairCounts` functions are wrappers around 
`dplyr::count` and enable counting frequencies of elements from one or two 
categorical columns in a Seurat or SingleCellExpression object:

```{r}
freq1 <- scColCounts(sceObj, 'donor')
freq2 <- scColCounts(seuratObj, 'donor')
identical(freq1, freq2)
head(freq1)
freq1 <- scColPairCounts(sceObj, 'donor', 'label')
freq2 <- scColPairCounts(seuratObj, 'donor', 'label')
identical(freq1, freq2)
head(freq1)
```

# Visualization

scLang includes three visualization functions that adapt Seurat visualization
tools, extending their usage to `SingleCellExpression` objects in addition to
`Seurat` objects.

The `dimPlot` function mimics the essential behavior of the `DimPlot` function 
from Seurat:

```{r}
dimPlot(sceObj, groupBy='label')
```

The `featurePlot` functions mimics the `FeaturePlot` function from Seurat 
(though using a different color scheme):

```{r}
featurePlot(sceObj, 'SOX4')
```

The `violinPlot` functions mimics the `ViolinPlot` function from Seurat:

```{r}
violinPlot(sceObj, 'SOX4', groupBy='label')
```

# Session information {-}
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generics.R, R/metadata.R
\name{scCol}
\alias{scCol}
\alias{scCol<-}
\alias{scCol.default}
\alias{scCol<-.default}
\alias{scCol.Seurat}
\alias{scCol<-.Seurat}
\alias{scCol.SingleCellExperiment}
\alias{scCol<-.SingleCellExperiment}
\title{Extract a metadata/coldata column from object.}
\usage{
scCol(scObj, col)

scCol(scObj, col) <- value

\method{scCol}{default}(scObj, col)

\method{scCol}{default}(scObj, col) <- value

\method{scCol}{Seurat}(scObj, col)

\method{scCol}{Seurat}(scObj, col) <- value

\method{scCol}{SingleCellExperiment}(scObj, col)

\method{scCol}{SingleCellExperiment}(scObj, col) <- value
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{col}{Column name.}

\item{value}{A vector to be added to the metadata/coldata of the
single-cell expression object.}
}
\value{
A vector.
}
\description{
This function extracts a metadata/coldata column from a \code{Seurat} or
\code{SingleCellExperiment} object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
v <- scCol(sceObj, 'Cluster')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dimred_names.R, R/generics.R
\name{dimredNames.default}
\alias{dimredNames.default}
\alias{dimredNames.Seurat}
\alias{dimredNames.SingleCellExperiment}
\alias{dimredNames}
\title{Extract the names of available dimensionality reductions from object}
\usage{
\method{dimredNames}{default}(scObj)

\method{dimredNames}{Seurat}(scObj)

\method{dimredNames}{SingleCellExperiment}(scObj)

dimredNames(scObj)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}
}
\value{
A character vector.
}
\description{
This function extracts the names of available dimensionality reductions
from a \code{Seurat} or \code{SingleCellExperiment} object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
dimredNames(sceObj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_expression.R, R/generics.R
\name{scGeneExp.default}
\alias{scGeneExp.default}
\alias{scGeneExp.Seurat}
\alias{scGeneExp.SingleCellExperiment}
\alias{scGeneExp.dgCMatrix}
\alias{scGeneExp.matrix}
\alias{scGeneExp}
\title{Extracts the expression of a single gene}
\usage{
\method{scGeneExp}{default}(scObj, gene, slot = NULL)

\method{scGeneExp}{Seurat}(scObj, gene, slot = "data")

\method{scGeneExp}{SingleCellExperiment}(scObj, gene, slot = "logcounts")

\method{scGeneExp}{dgCMatrix}(scObj, gene, slot = NULL)

\method{scGeneExp}{matrix}(scObj, gene, slot = NULL)

scGeneExp(scObj, gene, slot)
}
\arguments{
\item{scObj}{A \code{Seurat}, \code{SingleCellExperiment},
\code{dgCMatrix} or \code{matrix} object.}

\item{gene}{Selected gene.}

\item{slot}{Gene expression slot. Ignored if \code{scObj} is of class
\code{dgCMatrix} or \code{matrix}.}
}
\value{
A gene expression vector.
}
\description{
This function extracts the expression of a single gene from a \code{Seurat},
\code{SingleCellExperiment}, \code{dgCMatrix} or \code{matrix} object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
v <- scGeneExp(sceObj, 'Gene291')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualization.R
\name{dimPlot}
\alias{dimPlot}
\title{Creates a dimensionality reduction plot}
\usage{
dimPlot(
  scObj,
  groupBy = NULL,
  title = NULL,
  dimred = "umap",
  dims = c(1, 2),
  legendTitle = "Group",
  noGroupsLegendLab = "Object",
  palette = "grDevices::rainbow",
  pointSize = 0.5,
  alpha = 0.7,
  legendPos = c("right", "top", "left", "bottom"),
  legendTextSize = 10,
  legendTitleSize = 10,
  axisTextSize = 12,
  axisTitleSize = 12,
  ...
)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{groupBy}{Grouping variable. Must exist in the metadata/coldata of
the single-cell expression object.}

\item{title}{Plot title.}

\item{dimred}{Dimensionality reduction.}

\item{dims}{A numeric vector of size 2 representing the dimensions selected
for the plot.}

\item{legendTitle}{Legend title.}

\item{noGroupsLegendLab}{Legend label to be used when no grouping is
provided (\code{groupBy} is \code{NULL})}

\item{palette}{Color palette.}

\item{pointSize}{Point size.}

\item{alpha}{Opaqueness level.}

\item{legendPos}{Legend position.}

\item{legendTextSize}{Legend text size.}

\item{legendTitleSize}{Legend title size.}

\item{axisTextSize}{Axis text size.}

\item{axisTitleSize}{Axis title size.}

\item{...}{Additional arguments passed to \code{henna::centerTitle}.}
}
\value{
A dimensionality reduction plot.
}
\description{
This function creates a dimensionality reduction plot
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
dimPlot(sceObj, groupBy='Donor')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene_expression.R, R/generics.R
\name{scExpMat.default}
\alias{scExpMat.default}
\alias{scExpMat.Seurat}
\alias{scExpMat.SingleCellExperiment}
\alias{scExpMat.dgCMatrix}
\alias{scExpMat.matrix}
\alias{scExpMat}
\title{Extracts the expression matrix from object.}
\usage{
\method{scExpMat}{default}(scObj, slot = NULL, genes = NULL, densify = TRUE)

\method{scExpMat}{Seurat}(scObj, slot = "data", genes = NULL, densify = TRUE)

\method{scExpMat}{SingleCellExperiment}(scObj, slot = "logcounts", genes = NULL, densify = TRUE)

\method{scExpMat}{dgCMatrix}(scObj, slot = NULL, genes = NULL, densify = TRUE)

\method{scExpMat}{matrix}(scObj, slot = NULL, genes = NULL, densify = TRUE)

scExpMat(scObj, slot, genes = NULL, densify = TRUE)
}
\arguments{
\item{scObj}{A \code{Seurat}, \code{SingleCellExperiment},
\code{dgCMatrix} or \code{matrix} object.}

\item{slot}{Gene expression slot. Ignored if \code{scObj} is of class
\code{dgCMatrix} or \code{matrix}.}

\item{genes}{Selected genes. If \code{NULL}, all genes will be retained.}

\item{densify}{Whether to convert to dense matrix.}
}
\value{
An expression matrix.
}
\description{
This function extracts an expression matrix from a \code{Seurat} or
\code{SingleCellExperiment} object. For additional flexibility, the input
can alternatively be provided as a \code{dgCMatrix} object
(and an option to densify it is also available) or as a \code{matrix}
object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
mat <- scExpMat(sceObj, 'counts')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dimred_mat.R, R/generics.R
\name{scDimredMat.default}
\alias{scDimredMat.default}
\alias{scDimredMat.Seurat}
\alias{scDimredMat.SingleCellExperiment}
\alias{scDimredMat}
\title{Extracts a dimensionality reduction matrix from object.}
\usage{
\method{scDimredMat}{default}(scObj, dimred)

\method{scDimredMat}{Seurat}(scObj, dimred)

\method{scDimredMat}{SingleCellExperiment}(scObj, dimred)

scDimredMat(scObj, dimred)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{dimred}{Dimensionality reduction.}
}
\value{
A dimensionality reduction matrix.
}
\description{
This function extracts a dimensionality reduction matrix from a
\code{Seurat} or \code{SingleCellExperiment} object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
pcaMat <- scDimredMat(sceObj, 'pca')


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dimred_mat.R
\name{scUMAPMat}
\alias{scUMAPMat}
\title{Extracts the UMAP matrix from object.}
\usage{
scUMAPMat(scObj)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}
}
\value{
A UMAP matrix.
}
\description{
This function extracts the UMAP matrix from a Seurat or
SingleCellExperiment object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
umapMat <- scUMAPMat(sceObj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/counts_and_percentages.R
\name{scColPairCounts}
\alias{scColPairCounts}
\title{Extract counts from two columns of a single-cell expression
object}
\usage{
scColPairCounts(scObj, col1 = "seurat_clusters", col2 = "orig.ident")
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{col1}{Column as string.}

\item{col2}{Column as string.}
}
\value{
A data frame listing the counts of all combinations of pairs from
two categorical columns.
}
\description{
This function extracts count information from two columns of a single-cell
expression object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
scColPairCounts(sceObj, 'Cluster', 'Donor')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualization_utils.R
\name{pickFeature}
\alias{pickFeature}
\title{Extract feature data to be used by \code{featurePlot} or \code{violinPlot}}
\usage{
pickFeature(scObj, feature)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{feature}{A gene name or metadata column name.}
}
\value{
A numeric vector.
}
\description{
This function extracts feature data to be used by \code{featurePlot}
or \code{violinPlot}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualization.R
\name{violinPlot}
\alias{violinPlot}
\title{Create a violin plot to represent a feature}
\usage{
violinPlot(
  scObj,
  feature = rownames(scObj)[1],
  groupBy = metadataNames(scObj)[1],
  title = feature,
  legendTitle = NULL,
  xLab = "Identity",
  yLab = "Expression level",
  palette = "grDevices::rainbow",
  pointSize = 0.5,
  alpha = 0.8,
  legendPos = c("right", "top", "left", "bottom"),
  legendTextSize = 10,
  legendTitleSize = 10,
  axisTextSize = 12,
  axisTitleSize = 12,
  xLabAngle = 45,
  xLabVjust = 0.5,
  ...
)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{feature}{A gene name or metadata column name.}

\item{groupBy}{Grouping variable. Must exist in the metadata/coldata of
the single-cell expression object.}

\item{title}{Plot title.}

\item{legendTitle}{Legend title.}

\item{xLab}{x axis label.}

\item{yLab}{y axis label.}

\item{palette}{Color palette.}

\item{pointSize}{Point size.}

\item{alpha}{Opaqueness level.}

\item{legendPos}{Legend position.}

\item{legendTextSize}{Legend text size.}

\item{legendTitleSize}{Legend title size.}

\item{axisTextSize}{Axis text size.}

\item{axisTitleSize}{Axis title size.}

\item{xLabAngle}{x axis label angle.}

\item{xLabVjust}{x axis label vertical justification in [0, 1].}

\item{...}{Additional arguments passed to \code{henna::centerTitle}.}
}
\value{
A violin plot.
}
\description{
This function creates a violin plot to represent a
feature (gene expression or numeric metadata column).
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
violinPlot(sceObj, 'Gene289')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/counts_and_percentages.R
\name{scColCounts}
\alias{scColCounts}
\title{Extract per-group counts from the column of a single-cell expression object}
\usage{
scColCounts(scObj, col = "orig.ident")
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{col}{Column as string.}
}
\value{
A frequency vector with the unique column values as names.
}
\description{
This function extracts per-group counts from the column of single-cell
expression object.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
scColCounts(sceObj, 'Cluster')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generics.R, R/metadata.R
\name{metadataDF}
\alias{metadataDF}
\alias{metadataDF.default}
\alias{metadataDF.Seurat}
\alias{metadataDF.SingleCellExperiment}
\title{Extract metadata from object as a data frame}
\usage{
metadataDF(scObj)

\method{metadataDF}{default}(scObj)

\method{metadataDF}{Seurat}(scObj)

\method{metadataDF}{SingleCellExperiment}(scObj)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}
}
\value{
A metadata data frame.
}
\description{
This function extracts the metadata from a \code{Seurat} or
\code{SingleCellExperiment} object as a data frame.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
df <- metadataDF(sceObj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metadata.R
\name{metadataNames}
\alias{metadataNames}
\title{Return metadata names}
\usage{
metadataNames(scObj)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}
}
\value{
The names of the metadata columns.
}
\description{
This function extracts metadata names from a Seurat or
SingleCellExperiment object. It can also be used to modify metadata names.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
colNames <- metadataNames(sceObj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/documentation.R
\name{documentFun}
\alias{documentFun}
\title{Internal function used for documenting other functions}
\usage{
documentFun(
  scObj = NULL,
  title = NULL,
  groupBy = NULL,
  dimred = "umap",
  dims = c(1, 2),
  xLab = "x",
  yLab = "y",
  legendTitle = "Legend",
  legendLabs = c("a", "b"),
  legendPos = "right",
  palette = "Spectral",
  alpha = 1,
  pointSize = 0.8,
  legendTitleSize = 10,
  legendTextSize = 10,
  axisTextSize = 12,
  axisTitleSize = 12,
  ...
)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{title}{Plot title.}

\item{groupBy}{Grouping variable. Must exist in the metadata/coldata of
the single-cell expression object.}

\item{dimred}{Dimensionality reduction.}

\item{dims}{A numeric vector of size 2 representing the dimensions selected
for the plot.}

\item{xLab}{x axis label.}

\item{yLab}{y axis label.}

\item{legendTitle}{Legend title.}

\item{legendLabs}{Legend labels.}

\item{legendPos}{Legend position.}

\item{palette}{Color palette.}

\item{alpha}{Opaqueness level.}

\item{pointSize}{Point size.}

\item{legendTitleSize}{Legend title size.}

\item{legendTextSize}{Legend text size.}

\item{axisTextSize}{Axis text size.}

\item{axisTitleSize}{Axis title size.}

\item{...}{Additional arguments passed to \code{henna::centerTitle}.}
}
\value{
\code{NULL}. This function is only used internally for
documentation.
}
\description{
This function is used internally to help document other functions.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/counts_and_percentages.R
\name{scColPairPercs}
\alias{scColPairPercs}
\title{Extract percentages from two columns of a single-cell expression
object}
\usage{
scColPairPercs(scObj, col1, col2, sigDigits = 2)
}
\arguments{
\item{scObj}{A \code{Seurat} or \code{SingleCellExperiment} object.}

\item{col1}{Column as string.}

\item{col2}{Column as string.}

\item{sigDigits}{Number of significant digits.}
}
\value{
A data frame listing the percentages of all combinations of pairs
from two categorical columns.
}
\description{
This function extracts percentage information from two columns of a
single-cell expression object. For each i x j combination with i taken
from column 1 and j taken from column 2, the function reports the percentage
that i contributes to all combinations involving j.
}
\examples{
scePath <- system.file('extdata', 'sceObj.qs2', package='scLang')
sceObj <- qs2::qs_read(scePath)
scColPairPercs(sceObj, 'Cluster', 'Donor')

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scLang-package.R
\docType{package}
\name{scLang-package}
\alias{scLang}
\alias{scLang-package}
\title{scLang: A unified language for interacting with Seurat and SingleCellExperiment}
\description{
scLang is a suite for package development for scRNA-seq analysis. It offers functions that can operate on both Seurat and SingleCellExperiment objects. These functions are primarily aimed to help developers build tools compatible with both types of input.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/andrei-stoica26/scLang}
  \item Report bugs at \url{https://github.com/andrei-stoica26/scLang/issues}
}

}
\author{
\strong{Maintainer}: Andrei-Florian Stoica \email{andreistoica@foxmail.com} (\href{https://orcid.org/0000-0002-5253-0826}{ORCID})

}
\keyword{internal}
